## qt6-webengine 6.2.4.1

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
##
#  MAIN CONFIGURE
##

get_filename_component(WEBENGINE_ROOT_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/.." REALPATH)
get_filename_component(WEBENGINE_ROOT_BUILD_DIR "${PROJECT_BINARY_DIR}" REALPATH)

# Note this is configure that does not belong to any module
qt_feature_module_begin(ONLY_EVALUATE_FEATURES)
# Enable printing of feature summary by forcing qt_configure_record_command
# to work in spite of ONLY_EVALUATE_FEATURES.
set(__QtFeature_only_evaluate_features OFF)
include(../configure.cmake)
qt_feature_module_end(ONLY_EVALUATE_FEATURES)

##
#  SUPPORT CHECK
##

# TODO: here we should return FATAL_ERROR and ask user to define
# FEATURE_qtwebenignebuild=OFF if one wants to only build qtpdf,
# however our ci setup is not flexible enough and configure step must succeed

if(NOT ${QtWebEngine_SUPPORT})
    add_custom_target(WebEngineErrorMessage ALL
        ${CMAKE_COMMAND} -E cmake_echo_color --red "QtWebEngine will not be built: ${QtWebEngine_ERROR}"
        COMMENT "Check QtWebEngine support"
        VERBATIM
    )
    message("-- Support check for QtWebEngine failed: ${QtWebEngine_ERROR}")
    set(QT_FEATURE_qtwebengine_build OFF CACHE BOOL "Build QtWebEngine Modules" FORCE)
    set(QT_FEATURE_qtwebengine_core_build OFF CACHE BOOL "Build QtWebEngineCore" FORCE)
    set(QT_FEATURE_qtwebengine_widgets_build OFF CACHE BOOL "Build QtWebEngineWidgets" FORCE)
    set(QT_FEATURE_qtwebengine_quick_build OFF CACHE BOOL "Build QtWebEngineQuick" FORCE)

endif()

if(NOT ${QtPdf_SUPPORT})
    add_custom_target(PdfErrorMessage ALL
        ${CMAKE_COMMAND} -E cmake_echo_color --red "QtPdf will not be built: ${QtPdf_ERROR}"
        COMMENT "Check QtPdf support"
        VERBATIM
    )
    message("-- Support check for QtPdf failed: ${QtPdf_ERROR}")
    set(QT_FEATURE_qtpdf_build OFF CACHE BOOL "Build QtPdf" FORCE)
    set(QT_FEATURE_qtpdf_widgets_build OFF CACHE BOOL "Build QtPdfWidgets" FORCE)
    set(QT_FEATURE_qtpdf_quick_build OFF CACHE BOOL "Build QtPdfQuick" FORCE)
endif()

if(NOT QT_FEATURE_qtwebengine_build AND NOT QT_FEATURE_qtpdf_build)
    return()
endif()

##
#  MODULES
##

if(QT_FEATURE_qtwebengine_core_build)
   add_subdirectory(core)
   add_subdirectory(process)
endif()
if(QT_FEATURE_qtwebengine_widgets_build)
   add_subdirectory(webenginewidgets)
endif()
if(QT_FEATURE_qtwebengine_quick_build)
   add_subdirectory(webenginequick)
endif()

if(QT_FEATURE_qtpdf_build)
   add_subdirectory(pdf)
   # keep log order, pdf build after webengine
   if(QT_FEATURE_qtwebengine_core_build)
       add_dependencies(run_pdf_GnReady WebEngineCore)
   endif()
   if(QT_FEATURE_qtwebengine_widgets_build)
       add_dependencies(run_pdf_GnReady WebEngineWidgets)
   endif()
   if(QT_FEATURE_qtwebengine_quick_build)
       add_dependencies(run_pdf_GnReady WebEngineQuick)
   endif()
   if(QT_FEATURE_qtpdf_widgets_build)
       add_subdirectory(pdfwidgets)
   endif()
   if(QT_FEATURE_qtpdf_quick_build)
       add_subdirectory(pdfquick)
   endif()
endif()

##
#  NINJA PROJECT
##

set(installDir ${PROJECT_BINARY_DIR}/install)

if(NOT Ninja_FOUND)
    externalproject_add(ninja
        SOURCE_DIR  ${CMAKE_CURRENT_LIST_DIR}/ninja
        BINARY_DIR  ${CMAKE_CURRENT_BINARY_DIR}/ninja
        INSTALL_DIR ${installDir}
        PREFIX      ninja
        USES_TERMINAL_BUILD TRUE
        EXCLUDE_FROM_ALL TRUE
        CMAKE_ARGS -DCMAKE_BUILD_TYPE=Release
                   -DCMAKE_INSTALL_PREFIX:PATH=<INSTALL_DIR>
                   -DCMAKE_PREFIX_PATH:PATH=<INSTALL_DIR>
    )
    if(QT_FEATURE_qtwebengine_core_build)
        add_dependencies(run_core_NinjaReady ninja)
    endif()
    if(QT_FEATURE_qtpdf_build)
        add_dependencies(run_pdf_NinjaReady ninja)
    endif()
endif()

##
#  GN PROJECT
##

if(CMAKE_CROSSCOMPILING AND NOT Gn_FOUND)
   message(FATAL_ERROR "No gn found for cross-compilation")
endif()

if(NOT Gn_FOUND)
    externalproject_add(gn
        SOURCE_DIR  ${CMAKE_CURRENT_LIST_DIR}/gn
        BINARY_DIR  ${CMAKE_CURRENT_BINARY_DIR}/gn
        INSTALL_DIR ${installDir}
        PREFIX      gn
        USES_TERMINAL_BUILD TRUE
        EXCLUDE_FROM_ALL TRUE
        CMAKE_ARGS -DCMAKE_BUILD_TYPE=Release
                   -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}
                   -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}
                   -DCMAKE_INSTALL_PREFIX:PATH=<INSTALL_DIR>
                   -DCMAKE_PREFIX_PATH:PATH=<INSTALL_DIR>
                   -DWEBENGINE_ROOT_BUILD_DIR=${PROJECT_BINARY_DIR}
    )
    if(QT_FEATURE_qtwebengine_core_build)
        add_dependencies(run_core_GnReady gn)
    endif()
    if(QT_FEATURE_qtpdf_build)
        add_dependencies(run_pdf_GnReady gn)
    endif()
    set(INSTALL_GN 1 CACHE INTERNAL "")
endif()

##
#  HOST PROJECT
##

if(CMAKE_CROSSCOMPILING AND NOT IOS)

    if(NOT Gn_FOUND)
        message(FATAL_ERROR "\nHost gn not found - cross compilation not possible")
    endif()

    externalproject_add(hostBuild
        SOURCE_DIR  ${CMAKE_CURRENT_LIST_DIR}/host
        BINARY_DIR  ${CMAKE_CURRENT_BINARY_DIR}/host
        PREFIX      host
        USES_TERMINAL_BUILD TRUE
        EXCLUDE_FROM_ALL TRUE
        CMAKE_ARGS -DCMAKE_TOOLCHAIN_FILE=${QT_HOST_PATH}/lib/cmake/Qt6/qt.toolchain.cmake
                   -DWEBENGINE_ROOT_BUILD_DIR=${PROJECT_BINARY_DIR}
                   -DWEBENGINE_ROOT_SOURCE_DIR=${WEBENGINE_ROOT_SOURCE_DIR}
                   -DGN_TARGET_CPU=${TEST_architecture_arch}
                   -DCMAKE_C_FLAGS=
                   -DCMAKE_CXX_FLAGS=
                   -DQT_FEATURE_qtwebengine_build=${QT_FEATURE_qtwebengine_build}
                   -DQT_FEATURE_qtpdf_build=${QT_FEATURE_qtpdf_build}
    )
    if(QT_FEATURE_qtwebengine_build)
        add_dependencies(run_core_GnReady hostBuild)
    endif()
    if(QT_FEATURE_qtpdf_build)
        add_dependencies(run_pdf_GnReady hostBuild)
    endif()
endif()

# install gn for cross build
if((LINUX OR MACOS) AND INSTALL_GN)
    get_install_config(installConfig)
    install(
        PROGRAMS ${installDir}/bin/gn
        CONFIGURATIONS ${installConfig}
        RUNTIME DESTINATION "${INSTALL_LIBEXECDIR}"
    )
endif()

=== src/core/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

find_package(Ninja 1.7.2 REQUIRED)
find_package(Python2 2.7.5 REQUIRED)
find_package(Nodejs 10.19 REQUIRED)
find_package(PkgConfig)
if(PkgConfig_FOUND)
    pkg_check_modules(XSCRNSAVER xscrnsaver)
    create_pkg_config_host_wrapper(${CMAKE_CURRENT_BINARY_DIR})
endif()

set(buildDir "${CMAKE_CURRENT_BINARY_DIR}")

add_subdirectory(api)
add_subdirectory(tools)

##
#   TOOLCHAIN SETUP
##

if(LINUX)
    setup_toolchains()
endif()

##
#   GN BUILD SETUP
##

addSyncTargets(core)

get_configs(configs)
get_architectures(archs)

foreach(arch ${archs})
    foreach(config ${configs})

        ##
        # BUILD.gn SETUP
        ##

        set(buildGn core_${config}_${arch})
        add_gn_target(${buildGn} ${config} ${arch}
            SOURCES DEFINES CXX_COMPILE_OPTIONS C_COMPILE_OPTIONS INCLUDES MOC_PATH
        )
        resolve_target_includes(gnIncludes WebEngineCore)
        get_forward_declaration_macro(forwardDeclarationMacro)
        get_target_property(qtWebEngineProcessName WebEngineCore QTWEBENGINEPROCESS_NAME)

        if(QT_FEATURE_debug_and_release AND ("${config}" STREQUAL "Debug"))
            set(qtWebEngineProcessName "${qtWebEngineProcessName}${CMAKE_DEBUG_POSTFIX}")
        endif()

        set(gnCxxCompileOptions "")
        if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
            # Silence warning in boringssl headers.
            list(APPEND gnCxxCompileOptions -Wno-ignored-qualifiers)

            if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "11.0.0" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "11.2.0")
                # GCC 11.1 has a regression in the integrated preprocessor, so disable it as a workaround (QTBUG-93360)
                # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=100796
                list(APPEND gnCxxCompileOptions -no-integrated-cpp)
            endif()
        endif()

        extend_gn_target(${buildGn}
            INCLUDES
                ${gnIncludes}
            DEFINES
                QT_NO_KEYWORDS
                QT_USE_QSTRINGBUILDER
                QTWEBENGINECORE_VERSION_STR=\\\\\\\\\"${QT_REPO_MODULE_VERSION}\\\\\\\\\"
                QTWEBENGINEPROCESS_NAME=\\\\\\\\\"${qtWebEngineProcessName}\\\\\\\\\"
                BUILDING_CHROMIUM
                "${forwardDeclarationMacro}"
            CXX_COMPILE_OPTIONS
                ${gnCxxCompileOptions}
            SOURCES
                accessibility_activation_observer.cpp accessibility_activation_observer.h
                accessibility_tree_formatter_qt.cpp
                authentication_dialog_controller.cpp authentication_dialog_controller.h authentication_dialog_controller_p.h
                browser_accessibility_manager_qt.cpp browser_accessibility_manager_qt.h
                browser_accessibility_qt.cpp browser_accessibility_qt.h
                browser_main_parts_qt.cpp browser_main_parts_qt.h
                browser_message_filter_qt.cpp browser_message_filter_qt.h
                browsing_data_remover_delegate_qt.cpp browsing_data_remover_delegate_qt.h
                build_config_qt.h
                certificate_error_controller.cpp certificate_error_controller.h
                chromium_overrides.cpp
                client_cert_select_controller.cpp client_cert_select_controller.h
                clipboard_change_observer.h
                clipboard_qt.cpp clipboard_qt.h
                color_chooser_controller.cpp color_chooser_controller.h color_chooser_controller_p.h
                color_chooser_qt.cpp color_chooser_qt.h
                common/qt_messages.cpp common/qt_messages.h
                compositor/compositor.cpp compositor/compositor.h
                compositor/content_gpu_client_qt.cpp compositor/content_gpu_client_qt.h
                compositor/display_overrides.cpp
                compositor/display_software_output_surface.cpp compositor/display_software_output_surface.h
                content_browser_client_qt.cpp content_browser_client_qt.h
                content_client_qt.cpp content_client_qt.h
                content_main_delegate_qt.cpp content_main_delegate_qt.h
                content_utility_client_qt.cpp content_utility_client_qt.h
                delegated_frame_host_client_qt.cpp delegated_frame_host_client_qt.h
                desktop_screen_qt.cpp desktop_screen_qt.h
                devtools_frontend_qt.cpp devtools_frontend_qt.h
                devtools_manager_delegate_qt.cpp devtools_manager_delegate_qt.h
                download_manager_delegate_qt.cpp download_manager_delegate_qt.h
                favicon_driver_qt.cpp favicon_driver_qt.h
                favicon_service_factory_qt.cpp favicon_service_factory_qt.h
                file_picker_controller.cpp file_picker_controller.h
                find_text_helper.cpp find_text_helper.h
                global_descriptors_qt.h
                javascript_dialog_controller.cpp javascript_dialog_controller.h javascript_dialog_controller_p.h
                javascript_dialog_manager_qt.cpp javascript_dialog_manager_qt.h
                login_delegate_qt.cpp login_delegate_qt.h
                media_capture_devices_dispatcher.cpp media_capture_devices_dispatcher.h
                native_web_keyboard_event_qt.cpp
                net/client_cert_override.cpp net/client_cert_override.h
                net/client_cert_store_data.cpp net/client_cert_store_data.h
                net/cookie_monster_delegate_qt.cpp net/cookie_monster_delegate_qt.h
                net/custom_url_loader_factory.cpp net/custom_url_loader_factory.h
                net/proxy_config_monitor.cpp net/proxy_config_monitor.h
                net/proxy_config_service_qt.cpp net/proxy_config_service_qt.h
                net/proxying_restricted_cookie_manager_qt.cpp net/proxying_restricted_cookie_manager_qt.h
                net/proxying_url_loader_factory_qt.cpp net/proxying_url_loader_factory_qt.h
                net/qrc_url_scheme_handler.cpp net/qrc_url_scheme_handler.h
                net/ssl_host_state_delegate_qt.cpp net/ssl_host_state_delegate_qt.h
                net/system_network_context_manager.cpp net/system_network_context_manager.h
                net/url_request_custom_job_delegate.cpp net/url_request_custom_job_delegate.h
                net/url_request_custom_job_proxy.cpp net/url_request_custom_job_proxy.h
                net/webui_controller_factory_qt.cpp net/webui_controller_factory_qt.h
                ozone/gl_context_qt.cpp ozone/gl_context_qt.h
                ozone/gl_ozone_egl_qt.cpp ozone/gl_ozone_egl_qt.h
                ozone/gl_share_context_qt.cpp ozone/gl_share_context_qt.h
                ozone/gl_surface_egl_qt.cpp ozone/gl_surface_egl_qt.h
                ozone/gl_surface_qt.cpp ozone/gl_surface_qt.h
                ozone/gl_surface_wgl_qt.cpp ozone/gl_surface_wgl_qt.h
                ozone/platform_window_qt.cpp ozone/platform_window_qt.h
                ozone/surface_factory_qt.cpp ozone/surface_factory_qt.h
                permission_manager_qt.cpp permission_manager_qt.h
                platform_notification_service_qt.cpp platform_notification_service_qt.h
                pref_service_adapter.cpp pref_service_adapter.h
                process_main.cpp
                profile_adapter.cpp profile_adapter.h
                profile_adapter_client.cpp profile_adapter_client.h
                profile_io_data_qt.cpp profile_io_data_qt.h
                profile_qt.cpp profile_qt.h
                quota_permission_context_qt.cpp quota_permission_context_qt.h
                quota_request_controller.h
                quota_request_controller_impl.cpp quota_request_controller_impl.h
                register_protocol_handler_request_controller.h
                register_protocol_handler_request_controller_impl.cpp register_protocol_handler_request_controller_impl.h
                render_view_context_menu_qt.cpp render_view_context_menu_qt.h
                render_widget_host_view_qt.cpp render_widget_host_view_qt.h
                render_widget_host_view_qt_delegate.h
                render_widget_host_view_qt_delegate_client.cpp render_widget_host_view_qt_delegate_client.h
                renderer/content_renderer_client_qt.cpp renderer/content_renderer_client_qt.h
                renderer/content_settings_observer_qt.cpp renderer/content_settings_observer_qt.h
                renderer/render_configuration.cpp renderer/render_configuration.h
                renderer/render_frame_observer_qt.cpp renderer/render_frame_observer_qt.h
                renderer/user_resource_controller.cpp renderer/user_resource_controller.h
                renderer/web_engine_page_render_frame.cpp renderer/web_engine_page_render_frame.h
                renderer_host/user_resource_controller_host.cpp renderer_host/user_resource_controller_host.h
                renderer_host/web_engine_page_host.cpp renderer_host/web_engine_page_host.h
                request_controller.h
                resource_bundle_qt.cpp
                resource_context_qt.cpp resource_context_qt.h
                select_file_dialog_factory_qt.cpp select_file_dialog_factory_qt.h
                touch_handle_drawable_client.h
                touch_handle_drawable_qt.cpp touch_handle_drawable_qt.h
                touch_selection_controller_client_qt.cpp touch_selection_controller_client_qt.h
                touch_selection_menu_controller.cpp touch_selection_menu_controller.h
                type_conversion.cpp type_conversion.h
                user_notification_controller.cpp user_notification_controller.h
                user_script.cpp user_script.h
                visited_links_manager_qt.cpp visited_links_manager_qt.h
                web_contents_adapter.cpp web_contents_adapter.h
                web_contents_adapter_client.h
                web_contents_delegate_qt.cpp web_contents_delegate_qt.h
                web_contents_view_qt.cpp web_contents_view_qt.h
                web_engine_context.cpp web_engine_context.h
                web_engine_context_threads.cpp
                web_engine_error.cpp web_engine_error.h
                web_engine_library_info.cpp web_engine_library_info.h
                web_engine_settings.cpp web_engine_settings.h
                web_event_factory.cpp web_event_factory.h
        )

        extend_gn_target(${buildGn} CONDITION QT_FEATURE_webengine_ozone_x11
            SOURCES
                ozone/gl_ozone_glx_qt.cpp ozone/gl_ozone_glx_qt.h
                ozone/gl_surface_glx_qt.cpp ozone/gl_surface_glx_qt.h
        )

        extend_gn_target(${buildGn} CONDITION QT_FEATURE_opengl
            SOURCES
                compositor/compositor_resource_fence.cpp compositor/compositor_resource_fence.h
                compositor/display_gl_output_surface.cpp compositor/display_gl_output_surface.h
                compositor/display_skia_output_device.cpp compositor/display_skia_output_device.h
        )

        extend_gn_target(${buildGn} CONDITION MACOS AND QT_FEATURE_opengl
            SOURCES
                macos_context_type_helper.mm macos_context_type_helper.h
        )

        extend_gn_target(${buildGn} CONDITION QT_FEATURE_webengine_pepper_plugins
            SOURCES
                renderer/pepper/pepper_renderer_host_factory_qt.cpp renderer/pepper/pepper_renderer_host_factory_qt.h
                renderer/plugins/loadable_plugin_placeholder_qt.cpp renderer/plugins/loadable_plugin_placeholder_qt.h
                renderer_host/pepper/pepper_host_factory_qt.cpp renderer_host/pepper/pepper_host_factory_qt.h
                renderer_host/pepper/pepper_isolated_file_system_message_filter.cpp renderer_host/pepper/pepper_isolated_file_system_message_filter.h
        )

        extend_gn_target(${buildGn} CONDITION QT_FEATURE_webengine_printing_and_pdf
            SOURCES
                printing/pdfium_document_wrapper_qt.cpp printing/pdfium_document_wrapper_qt.h

=== src/gn/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.19)

project(Gn
    DESCRIPTION "Meta-build system"
    HOMEPAGE_URL "https://gn.googlesource.com/gn/"
    LANGUAGES CXX C
)

if(NOT DEFINED WEBENGINE_ROOT_SOURCE_DIR)
    get_filename_component(WEBENGINE_ROOT_SOURCE_DIR "${CMAKE_CURRENT_LIST_DIR}/../.." REALPATH)
endif()

include(${WEBENGINE_ROOT_SOURCE_DIR}/.cmake.conf)

set(GN_SOURCE_DIR ${WEBENGINE_ROOT_SOURCE_DIR}/src/3rdparty/gn)
set(GN_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${WEBENGINE_ROOT_SOURCE_DIR}/cmake")

find_package(Python2 REQUIRED)
find_package(Ninja 1.7.2 REQUIRED)

if(WIN32)
    set(GN_EXECUTABLE gn.exe)
else()
    set(GN_EXECUTABLE gn)
endif()

file(MAKE_DIRECTORY ${GN_BINARY_DIR})
add_custom_command(
    OUTPUT ${GN_EXECUTABLE}
    WORKING_DIRECTORY ${GN_BINARY_DIR}
    COMMAND ${Python2_EXECUTABLE} ${GN_SOURCE_DIR}/build/gen.py
        --no-last-commit-position
        --out-path ${GN_BINARY_DIR}/$<CONFIG>
        --cc ${CMAKE_C_COMPILER}
        --cxx ${CMAKE_CXX_COMPILER}
        --ld ${CMAKE_CXX_COMPILER}
        --qt-version "${QT_REPO_MODULE_VERSION}.qtwebengine.qt.io"
        $<$<PLATFORM_ID:Darwin>:--isysroot>
        $<$<PLATFORM_ID:Darwin>:${CMAKE_OSX_SYSROOT}>
    COMMAND Ninja::ninja -C ${GN_BINARY_DIR}/$<CONFIG> ${GN_EXECUTABLE}
    VERBATIM
    USES_TERMINAL
    COMMAND_EXPAND_LISTS
)
add_custom_target(Gn ALL DEPENDS ${GN_EXECUTABLE})
install(PROGRAMS ${GN_BINARY_DIR}/$<CONFIG>/${GN_EXECUTABLE}
        DESTINATION bin
)

=== src/ninja/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.19)

project(Ninja
    DESCRIPTION "Ninja Build Tool"
    HOMEPAGE_URL "https://ninja-build.org/"
    LANGUAGES CXX C
)

set(NINJA_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/ninja)
set(NINJA_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

find_package(Python2 REQUIRED)

if(WIN32)
    set(NINJA_EXECUTABLE ninja.exe)
else()
    set(NINJA_EXECUTABLE ninja)
endif()

file(MAKE_DIRECTORY ${NINJA_BINARY_DIR})

add_custom_command(
    OUTPUT ${NINJA_EXECUTABLE}
    WORKING_DIRECTORY ${NINJA_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E make_directory ${NINJA_BINARY_DIR}/$<CONFIG>
    COMMAND ${CMAKE_COMMAND} -E chdir ${NINJA_BINARY_DIR}/$<CONFIG>
        ${Python2_EXECUTABLE} ${NINJA_SOURCE_DIR}/configure.py --bootstrap
    USES_TERMINAL
    VERBATIM
)
add_custom_target(Ninja ALL DEPENDS ${NINJA_EXECUTABLE})
install(FILES ${NINJA_BINARY_DIR}/$<CONFIG>/${NINJA_EXECUTABLE}
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
    DESTINATION bin
)

=== src/pdf/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
find_package(Ninja 1.7.2 REQUIRED)
find_package(Python2 2.7.5 REQUIRED)
find_package(Nodejs 10.19 REQUIRED)
find_package(PkgConfig)
if(PkgConfig_FOUND)
    create_pkg_config_host_wrapper(${CMAKE_CURRENT_BINARY_DIR})
endif()

set(buildDir "${CMAKE_CURRENT_BINARY_DIR}")

##
#  PDF MODULE
##

qt_internal_add_module(Pdf
    SOURCES
        qpdfbookmarkmodel.cpp qpdfbookmarkmodel.h
        qpdfdestination.cpp qpdfdestination.h qpdfdestination_p.h
        qpdfdocument.cpp qpdfdocument.h qpdfdocument_p.h
        qpdfdocumentrenderoptions.h
        qpdflinkmodel.cpp qpdflinkmodel_p.h qpdflinkmodel_p_p.h
        qpdfpagenavigation.cpp qpdfpagenavigation.h
        qpdfpagerenderer.cpp qpdfpagerenderer.h
        qpdfsearchmodel.cpp qpdfsearchmodel.h qpdfsearchmodel_p.h
        qpdfsearchresult.cpp qpdfsearchresult.h qpdfsearchresult_p.h
        qpdfselection.cpp qpdfselection.h qpdfselection_p.h
        qtpdfglobal.h
        qpdfnamespace.h
    INCLUDE_DIRECTORIES
        ../3rdparty/chromium
    DEFINES
        QT_BUILD_PDF_LIB
        NOMINMAX
    LIBRARIES
        Qt::CorePrivate
        Qt::Network
    PUBLIC_LIBRARIES
        Qt::Core
        Qt::Gui
)

add_subdirectory(plugins/imageformats/pdf)

##
#  PDF DOCS
##

qt_internal_add_docs(Pdf
    doc/qtpdf.qdocconf
)


##
#   TOOLCHAIN SETUP
##

if(LINUX)
    setup_toolchains()
endif()

##
#   GN BUILD SETUP
##

addSyncTargets(pdf)

get_configs(configs)
get_architectures(archs)

foreach(arch ${archs})
    foreach(config ${configs})

        ##
        #   BULID.gn SETUP
        ##

        set(buildGn pdf_${config}_${arch})
        add_gn_target(${buildGn} ${config} ${arch}
            SOURCES DEFINES CXX_COMPILE_OPTIONS C_COMPILE_OPTIONS INCLUDES MOC_PATH
        )
        resolve_target_includes(gnIncludes Pdf)
        get_forward_declaration_macro(forwardDeclarationMacro)

        extend_gn_target(${buildGn}
            INCLUDES
                ${gnIncludes}
        )

        ##
        #  GN PARAMETERS
        ##

        unset(gnArgArg)
        append_build_type_setup(gnArgArg)
        append_compiler_linker_sdk_setup(gnArgArg)
        append_sanitizer_setup(gnArgArg)
        append_toolchain_setup(gnArgArg)
        append_pkg_config_setup(gnArgArg)

        list(APPEND gnArgArg
          qtwebengine_target="${buildDir}/${config}/${arch}:QtPdf"
          enable_remoting=false
          enable_resource_allowlist_generation=false
          enable_web_speech=false
          chrome_pgo_phase=0
        )

        if(LINUX)
          list(APPEND gnArgArg
              use_x11=false
              is_cfi=false
              ozone_auto_platforms=false
              use_gnome_keyring=false)
        endif()
        if(MACOS)
          list(APPEND gnArgArg angle_enable_vulkan=false)
        endif()
        if(WIN32)
          list(APPEND gnArgArg
              ninja_use_custom_environment_files=false
              safe_browsing_mode=0
          )
        endif()

        extend_gn_list(gnArgArg
            ARGS pdf_enable_v8
            CONDITION QT_FEATURE_pdf_v8
        )
        extend_gn_list(gnArgArg
            ARGS pdf_enable_xfa
            CONDITION QT_FEATURE_pdf_xfa
        )
        extend_gn_list(gnArgArg
            ARGS pdf_enable_xfa_bmp
            CONDITION QT_FEATURE_pdf_xfa_bmp
        )
        extend_gn_list(gnArgArg
            ARGS pdf_enable_xfa_gif
            CONDITION QT_FEATURE_pdf_xfa_gif
        )
        extend_gn_list(gnArgArg
            ARGS pdf_enable_xfa_png
            CONDITION QT_FEATURE_pdf_xfa_png
        )
        extend_gn_list(gnArgArg
            ARGS pdf_enable_xfa_tiff
            CONDITION QT_FEATURE_pdf_xfa_tiff
        )

        add_gn_command(
            CMAKE_TARGET Pdf
            NINJA_TARGETS QtPdf
            GN_TARGET ${buildGn}
            GN_ARGS "${gnArgArg}"
            BUILDDIR ${buildDir}/${config}/${arch}
            MODULE pdf
        )

    endforeach()
    create_cxx_configs(Pdf ${arch})
endforeach()


##
#  PDF SETUP
##

set(arch ${CMAKE_SYSTEM_PROCESSOR})
target_include_directories(Pdf PRIVATE ${buildDir}/$<CONFIG>/${arch}/gen)
add_gn_build_aritfacts_to_target(Pdf QtPdf pdf ${buildDir} TRUE)
add_dependencies(Pdf run_pdf_NinjaDone)

=== src/pdfquick/CMakeLists.txt ===
find_package(Qt6 ${PROJECT_VERSION} CONFIG REQUIRED COMPONENTS Core Gui Qml Quick)

set(qml_files
# TODO:
#    "qml/+material/PdfStyle.qml"
#    "qml/+universal/PdfStyle.qml"
    "qml/PdfMultiPageView.qml"
    "qml/PdfPageView.qml"
    "qml/PdfScrollablePageView.qml"
    "qml/PdfStyle.qml"
)

qt_internal_add_qml_module(PdfQuick
    URI "QtQuick.Pdf"
    VERSION "${PROJECT_VERSION}"
    CLASS_NAME QtQuick2PdfPlugin
    NO_GENERATE_PLUGIN_SOURCE
    NO_PLUGIN_OPTIONAL
    NO_GENERATE_QMLTYPES
    PLUGIN_TARGET qtpdfquickplugin
    QML_FILES ${qml_files}
    DEPENDENCIES QtQuickControls2
    SOURCES
        qquickpdfdocument.cpp qquickpdfdocument_p.h
        qquickpdflinkmodel.cpp qquickpdflinkmodel_p.h
        qquickpdfnavigationstack.cpp qquickpdfnavigationstack_p.h
        qquickpdfsearchmodel.cpp qquickpdfsearchmodel_p.h
        qquickpdfselection.cpp qquickpdfselection_p.h
        qquicktableviewextra.cpp qquicktableviewextra_p.h
        qtpdfquickglobal_p.h
    INCLUDE_DIRECTORIES
        ../3rdparty/chromium
    PUBLIC_LIBRARIES
        Qt::QuickPrivate
        Qt::PdfPrivate
        Qt::Core
        Qt::Gui
        Qt::Qml
)

qt_internal_extend_target(qtpdfquickplugin
    SOURCES
        plugin.cpp
    LIBRARIES
        Qt::CorePrivate
        Qt::PdfQuickPrivate
)

=== tests/auto/CMakeLists.txt ===
if(TARGET Qt::WebEngineCore)
    add_subdirectory(httpserver)
    add_subdirectory(util)
    add_subdirectory(core)
endif()
if(TARGET Qt::WebEngineQuick)
    add_subdirectory(quick)
endif()
if(TARGET Qt::WebEngineWidgets)
    add_subdirectory(widgets)
endif()
if(TARGET Qt::Pdf)
    add_subdirectory(pdf)
endif()

=== src/core/api/CMakeLists.txt ===
find_package(Qt6 ${PROJECT_VERSION} REQUIRED COMPONENTS Gui Network Quick)
find_package(Qt6 ${PROJECT_VERSION} QUIET OPTIONAL_COMPONENTS WebChannel Positioning)

set(qtWebEngineProcessName QtWebEngineProcess)

qt_internal_add_module(WebEngineCore
     SOURCES
        qtwebenginecoreglobal.cpp qtwebenginecoreglobal.h qtwebenginecoreglobal_p.h
        qwebenginecertificateerror.cpp qwebenginecertificateerror.h
        qwebengineclientcertificateselection.cpp qwebengineclientcertificateselection.h
        qwebengineclientcertificatestore.cpp qwebengineclientcertificatestore.h
        qwebenginecontextmenurequest.cpp qwebenginecontextmenurequest.h qwebenginecontextmenurequest_p.h
        qwebenginecookiestore.cpp qwebenginecookiestore.h qwebenginecookiestore_p.h
        qwebenginedownloadrequest.cpp qwebenginedownloadrequest.h qwebenginedownloadrequest_p.h
        qwebenginefindtextresult.cpp qwebenginefindtextresult.h
        qwebenginefullscreenrequest.cpp qwebenginefullscreenrequest.h
        qwebenginehistory.cpp qwebenginehistory.h qwebenginehistory_p.h
        qwebenginehttprequest.cpp qwebenginehttprequest.h
        qwebengineloadinginfo.cpp qwebengineloadinginfo.h
        qwebenginemessagepumpscheduler.cpp qwebenginemessagepumpscheduler_p.h
        qwebenginenavigationrequest.cpp qwebenginenavigationrequest.h
        qwebenginenewwindowrequest.cpp qwebenginenewwindowrequest.h qwebenginenewwindowrequest_p.h
        qwebenginenotification.cpp qwebenginenotification.h
        qwebenginepage.cpp qwebenginepage.h qwebenginepage_p.h
        qwebengineprofile.cpp qwebengineprofile.h qwebengineprofile_p.h
        qwebenginequotarequest.cpp qwebenginequotarequest.h
        qwebengineregisterprotocolhandlerrequest.cpp qwebengineregisterprotocolhandlerrequest.h
        qwebenginescript.cpp qwebenginescript.h
        qwebenginescriptcollection.cpp qwebenginescriptcollection.h qwebenginescriptcollection_p.h
        qwebenginesettings.cpp qwebenginesettings.h
        qwebengineurlrequestinfo.cpp qwebengineurlrequestinfo.h qwebengineurlrequestinfo_p.h
        qwebengineurlrequestinterceptor.h
        qwebengineurlrequestjob.cpp qwebengineurlrequestjob.h
        qwebengineurlscheme.cpp qwebengineurlscheme.h
        qwebengineurlschemehandler.cpp qwebengineurlschemehandler.h
    DEFINES
        BUILDING_CHROMIUM
        NOMINMAX
    INCLUDE_DIRECTORIES
        ../
        ../../3rdparty/chromium
        ../../3rdparty/chromium/third_party/abseil-cpp
        ../../3rdparty/chromium/third_party/perfetto/include
    LIBRARIES
        Qt::CorePrivate
        Qt::GuiPrivate
        Qt::QuickPrivate
    PUBLIC_LIBRARIES
        Qt::Core
        Qt::Gui
        Qt::Network
        Qt::Quick
)

set_target_properties(WebEngineCore PROPERTIES QTWEBENGINEPROCESS_NAME ${qtWebEngineProcessName})

# Chromium included headers are not clean
qt_skip_warnings_are_errors(WebEngineCore)

if(CLANG OR GCC)
    target_compile_options(WebEngineCore PRIVATE "-Wno-unused-parameter")
endif()

qt_internal_extend_target(WebEngineCore CONDITION QT_FEATURE_webengine_webchannel
    PUBLIC_LIBRARIES
        Qt::WebChannel
)
qt_internal_extend_target(WebEngineCore CONDITION QT_FEATURE_webengine_geolocation
    PUBLIC_LIBRARIES
        Qt::Positioning
)

##
#  DOCS
##

qt_internal_add_docs(WebEngineCore
    ../doc/qtwebengine.qdocconf
)

add_custom_command(
    OUTPUT chromium_attributions.qdoc
    COMMAND ${Python2_EXECUTABLE} chromium/tools/licenses.py
        --file-template ../core/doc/about_credits.tmpl
        --entry-template ../core/doc/about_credits_entry.tmpl
        credits ${CMAKE_CURRENT_BINARY_DIR}/chromium_attributions.qdoc
    DEPENDS ../doc/about_credits.tmpl ../doc/about_credits_entry.tmpl
    WORKING_DIRECTORY ${WEBENGINE_ROOT_SOURCE_DIR}/src/3rdparty
    USES_TERMINAL
)
add_custom_target(generate_chromium_attributions DEPENDS chromium_attributions.qdoc)
add_dependencies(generate_docs_WebEngineCore generate_chromium_attributions)

##
#  WEBENGINECORE RESOURCES
##

set(arch ${CMAKE_SYSTEM_PROCESSOR})
#TODO: use simply filter / globbing-expressions
set(localeList am ar bg bn ca cs da de el en-GB en-US es-419 es et fa fi fil fr
    gu he hi hr hu id it ja kn ko lt lv ml mr ms nb nl pl pt-BR pt-PT ro ru sk
    sl sr sv sw ta te th tr uk vi zh-CN zh-TW)

set(resourceList qtwebengine_resources.pak
    qtwebengine_resources_100p.pak
    qtwebengine_resources_200p.pak
    qtwebengine_devtools_resources.pak)

get_install_config(config)

foreach(loc ${localeList})
    get_filename_component(locSourcePath ${buildDir}/${config}/${arch}/qtwebengine_locales/${loc}.pak REALPATH)
    list(APPEND localeFiles ${locSourcePath})
endforeach()

foreach(res ${resourceList})
    get_filename_component(resSourcePath ${buildDir}/${config}/${arch}/${res} REALPATH)
    list(APPEND resourceFiles ${resSourcePath})
endforeach()

if (NOT QT_FEATURE_webengine_system_icu)
    get_filename_component(icuFile ${buildDir}/${config}/${arch}/icudtl.dat REALPATH)
    list(APPEND resourceFiles ${icuFile})
    set_target_properties(WebEngineCore PROPERTIES ICUDTL_FILE ${icuFile})
endif()

if(QT_FEATURE_framework)
    set(allResourceFiles ${localeFiles} ${resourceFiles})
    target_sources(WebEngineCore PRIVATE ${allResourceFiles})

    set_source_files_properties(${localeFiles}
        TARGET_DIRECTORY WebEngineCore
        PROPERTIES MACOSX_PACKAGE_LOCATION Resources/qtwebengine_locales
        GENERATED TRUE
    )
    set_source_files_properties(${resourceFiles}
        TARGET_DIRECTORY WebEngineCore
        PROPERTIES MACOSX_PACKAGE_LOCATION Resources
        GENERATED TRUE
    )

    add_custom_command(OUTPUT ${allResourceFiles} DEPENDS ${buildDir}/${config}/${arch}/QtWebEngineCore.stamp)
    add_custom_target(generate_resources_${config} DEPENDS ${allResourceFiles})
else()
    install(FILES ${localeFiles}
        DESTINATION ${INSTALL_TRANSLATIONSDIR}/qtwebengine_locales
        CONFIGURATIONS ${config}
    )
    install(FILES ${resourceFiles}
        DESTINATION ${INSTALL_DATADIR}/resources
        CONFIGURATIONS ${config}
    )
    if(QT_SUPERBUILD OR NOT QT_WILL_INSTALL)
        addCopyCommand(WebEngineCore "${localeFiles}"
            ${QT_BUILD_DIR}/${INSTALL_TRANSLATIONSDIR}/qtwebengine_locales
        )
        addCopyCommand(WebEngineCore "${resourceFiles}"
            ${QT_BUILD_DIR}/${INSTALL_DATADIR}/resources
        )
   endif()
endif()

=== src/core/tools/CMakeLists.txt ===

##
#  WEBENGINECORE DICT CONVERT TOOL
##

if(QT_FEATURE_webengine_spellchecker)
    qt_get_tool_target_name(dict_target_name qwebengine_convert_dict)
    qt_internal_add_tool(${dict_target_name}
        TARGET_DESCRIPTION "QtWebEngine Dictionary Conversion Tool"
        INSTALL_DIR ${INSTALL_LIBEXECDIR}
        TOOLS_TARGET WebEngineCore
        SOURCES main.cpp
    )
    qt_skip_warnings_are_errors(${dict_target_name})
    add_dependencies(${dict_target_name} WebEngineCore)
    qt_internal_extend_target(${dict_target_name} CONDITION WIN32
        DEFINES WIN32_LEAN_AND_MEAN NOMINMAX
    )
    qt_internal_extend_target(${dict_target_name} CONDITION GCC OR CLANG
        COMPILE_OPTIONS -Wno-unused-parameter
    )
    if(NOT QT_FEATURE_webengine_system_icu AND QT_WILL_INSTALL)
        # tool can be called durig build so copy icu file
        get_target_property(icuFile WebEngineCore ICUDTL_FILE)
        addCopyCommand(${dict_target_name} "${icuFile}"
            "${QT_BUILD_DIR}/${INSTALL_LIBEXECDIR}")
    endif()
    qt_internal_extend_target(${dict_target_name}
        CONDITION NOT QT_FEATURE_webengine_system_icu
        DEFINES USE_ICU_FILE
    )
endif()

=== tests/auto/core/qwebengineclientcertificatestore/CMakeLists.txt ===
qt_internal_add_test(tst_qwebengineclientcertificatestore
    SOURCES
        tst_qwebengineclientcertificatestore.cpp
    LIBRARIES
        Qt::WebEngineCore
)

set(tst_qwebengineclientcertificatestore_resource_files
    "resources/certificate.crt"
    "resources/certificate1.crt"
    "resources/privatekey.key"
    "resources/privatekey1.key"
)

qt_internal_add_resource(tst_qwebengineclientcertificatestore "tst_qwebengineclientcertificatestore"
    PREFIX
        "/"
    FILES
        ${tst_qwebengineclientcertificatestore_resource_files}
)

=== tests/auto/core/qwebengineurlrequestinterceptor/CMakeLists.txt ===
include(../../util/util.cmake)
include(../../httpserver/httpserver.cmake)

qt_internal_add_test(tst_qwebengineurlrequestinterceptor
    SOURCES
        tst_qwebengineurlrequestinterceptor.cpp
    LIBRARIES
        Qt::WebEngineCore
        Test::HttpServer
        Test::Util
)

set(tst_qwebengineurlrequestinterceptor_resource_files
    "resources/content.html"
    "resources/favicon.html"
    "resources/firstparty.html"
    "resources/fontawesome.woff"
    "resources/icons/favicon.png"
    "resources/iframe.html"
    "resources/iframe2.html"
    "resources/iframe3.html"
    "resources/image.html"
    "resources/image_in_iframe.html"
    "resources/index.html"
    "resources/media.html"
    "resources/media.mp4"
    "resources/media_in_iframe.html"
    "resources/resource.html"
    "resources/resource_in_iframe.html"
    "resources/script.js"
    "resources/style.css"
    "resources/sw.html"
    "resources/sw.js"
)

qt_internal_add_resource(tst_qwebengineurlrequestinterceptor "tst_qwebengineurlrequestinterceptor"
    PREFIX
        "/"
    FILES
        ${tst_qwebengineurlrequestinterceptor_resource_files}
)

=== tests/auto/pdf/qpdfdocument/CMakeLists.txt ===
qt_internal_add_test(tst_qpdfdocument
    SOURCES
        tst_qpdfdocument.cpp
    PUBLIC_LIBRARIES
        Qt::Gui
        Qt::Network
        Qt::PrintSupport
        Qt::Pdf
)

=== debian/changelog ===
qt6-webengine (6.2.4.1-1+dde) unstable; urgency=medium

  * update to upstream verson 6.2.4
  * set ninja maxjobs num to -j16
  * fit gcc 8.3.0

 -- Ma Aiguo <maaiguo@uniontech.com>  Wed, 15 Jun 2022 13:32:05 +0800

qt6-webengine (6.2.4+dfsg-8) unstable; urgency=medium

  [ Patrick Franz ]
  * Remove lower_libicu_min_to_67.patch as libicu 71 is now available.
  * Make qt6-webengine-dev depend on qt6-webengine-dev-tools as it needs
    it.

 -- Patrick Franz <deltaone@debian.org>  Thu, 26 May 2022 13:27:19 +0200

qt6-webengine (6.2.4+dfsg-7) unstable; urgency=medium

  [ Patrick Franz ]
  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Fri, 22 Apr 2022 20:08:01 +0200

=== debian/control ===
Source: qt6-webengine
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Patrick Franz <deltaone@debian.org>, Lu YaNing <dluyaning@gmail.com>
Build-Depends: binutils (>= 2.31),
               bison,
               cmake (>= 3.19~),
               debhelper-compat (= 13),
               flex,
               gperf,
               libavcodec-dev (>= 7:4.0~),
               libavformat-dev (>= 7:4.0~),
               libavutil-dev (>= 7:4.0~),
               libcups2-dev (>= 1.5.0),
               libdbus-1-dev,
               libegl1-mesa-dev,
               libevent-dev,
               libfontconfig1-dev,
               libgl-dev,
               libgles-dev,
               libglib2.0-dev,
               libglu1-mesa-dev,
               libgstreamer-plugins-base1.0-dev,
               libgstreamer1.0-dev,
               libharfbuzz-dev,
               libicu-dev,
               libjpeg-dev,
               libjs-d3,
               libjs-jquery,
               libjs-jquery-tablesorter,
               libjsoncpp-dev,
               libkrb5-dev,
               liblcms2-dev,
               libminizip-dev,
               libnss3-dev,
               libopus-dev (>= 1.3.1),
               libpci-dev,
               libpng-dev,
               libprotobuf-dev,
               libpulse-dev,
               libqt6opengl6-dev (>= 6.2.4),
               libqt6webchannel6-dev (>= 6.2.4),
               libre2-dev,
               libsnappy-dev,
               libsqlite3-dev,
               libssl-dev,
               libusb-1.0-0-dev,
               libvpx-dev (>= 1.7),
               libvulkan-dev [linux-any],
               libwayland-dev (>= 1.8.0),
               libwebp-dev,
               libx11-xcb-dev,
               libxcb-dri3-dev,
               libxcomposite-dev,
               libxcursor-dev,
               libxdamage-dev,
               libxkbcommon-dev (>= 0.2.0),
               libxkbfile-dev,
               libxml2-dev,
               libxnvctrl-dev,
               libxrandr-dev,
               libxrender-dev,
               libxshmfence-dev,
               libxslt1-dev,
               libxss-dev,
               libxtst-dev,
               mesa-common-dev,
               ninja-build,
               node-pako,
               node-yargs,
               nodejs,
               pkg-config,
               pkg-kde-tools,
               protobuf-compiler,
               python2,
               qt6-base-dev (>= 6.2.4),
               qt6-base-private-dev (>= 6.2.4),
               qt6-declarative-dev (>= 6.2.4),
               qt6-declarative-private-dev (>= 6.2.4),
               qt6-positioning-dev (>= 6.2.4),
               qt6-tools-dev (>= 6.2.4),
               re2c,
               rollup,
               ruby,
               xauth <!nocheck>,
               xvfb <!nocheck>,
Standards-Version: 4.6.0
Homepage: https://www.qt.io/developers/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt6/qt6-webengine
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt6/qt6-webengine.git
Rules-Requires-Root: no

Package: libqt6webenginecore6
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: libqt6webengine6-data (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Pre-Depends: ${misc:Pre-Depends}
Provides: qt6-webengine-abi (= 6.2.4)
Description: Qt 6 WebEngine Core library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 Qt WebEngine provides a Web browser engine that makes it easy to embed content
 from the World Wide Web into your Qt application.
 .
 This package contains the Qt 6 WebEngine Core library.

Package: libqt6pdf6
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 PDF library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The Qt PDF module contains classes and functions for rendering PDF documents.
 .
 This package contains the Qt 6 PDF library.

Package: libqt6pdfquick6
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Qt 6 PDF Quick library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The Qt PDF module contains classes and functions for rendering PDF documents.
 .
 This package contains the Qt 6 PDF Quick library.

Package: libqt6pdfwidgets6
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 PDF Widgets library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The Qt PDF module contains classes and functions for rendering PDF documents.
 .
 This package contains the Qt 6 PDF Widgets library.

Package: libqt6webenginecore6-bin
Architecture: amd64 arm64 armhf i386
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Qt 6 WebEngine Core binaries
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 Qt WebEngine provides a Web browser engine that makes it easy to embed content
 from the World Wide Web into your Qt application.
 .
 This package contains the Qt 6 WebEngine Core binaries.

Package: libqt6webenginequick6
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Qt 6 WebEngine Quick library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 Qt WebEngine provides a Web browser engine that makes it easy to embed content
 from the World Wide Web into your Qt application.
 .
 This package contains the Qt 6 WebEngine Quick library.

Package: libqt6webenginequickdelegatesqml6
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Qt 6 WebEngine Quick Delegates QML library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 Qt WebEngine provides a Web browser engine that makes it easy to embed content
 from the World Wide Web into your Qt application.
 .
 This package contains the Qt 6 WebEngine Quick Delegates QML library.

Package: libqt6webenginewidgets6
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: libqt6webengine6-data (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Pre-Depends: ${misc:Pre-Depends}
Description: Qt 6 WebEngine Widgets library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 Qt WebEngine provides a Web browser engine that makes it easy to embed content
 from the World Wide Web into your Qt application.
 .
 This package contains the Qt 6 WebEngine Widgets library.

Package: libqt6webengine6-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Qt 6 Web content engine library - data
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 Qt WebEngine provides a Web browser engine that makes it easy to embed content
 from the World Wide Web into your Qt application.
 .
 This package contains the arch independent parts of Qt WebEngine libraries.

Package: qt6-image-formats-plugin-pdf
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 PDF image format plugin
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The Qt PDF module contains classes and functions for rendering PDF documents.
 .
 This package provides an image plugin that allows image-viewing applications
 to view PDF files (the first page of PDF will be shown).

Package: qml6-module-qtquick-pdf
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: qml6-module-qtquick (>= 6.2.4),
         qml6-module-qtquick-controls (>= 6.2.4),
         qml6-module-qtquick-shapes (>= 6.2.4),
         qml6-module-qtquick-templates (>= 6.2.4),
         qml6-module-qtquick-window (>= 6.2.4),
         qt6-image-formats-plugin-pdf,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Qt 6 Quick PDF QML module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The Qt PDF module contains classes and functions for rendering PDF documents.
 .
 This package contains the Qt 6 Quick PDF QML module.

Package: qml6-module-qtwebengine
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: qml6-module-qtquick, ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Qt 6 WebEngine QML module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 Qt WebEngine provides a Web browser engine that makes it easy to embed content
 from the World Wide Web into your Qt application.
 .
 This package contains the Qt 6 WebEngine QML module for Qt 6 Declarative.

Package: qml6-module-qtwebengine-controlsdelegates
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Depends: qml6-module-qtquick, ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Qt 6 WebEngine Controls Delegates QML module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 Qt WebEngine provides a Web browser engine that makes it easy to embed content
 from the World Wide Web into your Qt application.
 .
 This package contains the Qt 6 WebEngine Controls Delegates QML module
 for Qt 6 Declarative.

Package: qt6-webengine-dev
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Section: libdevel
Depends: libqt6webchannel6-dev,
         libqt6webenginecore6 (= ${binary:Version}),
         libqt6webenginequick6 (= ${binary:Version}),
         libqt6webenginequickdelegatesqml6 (= ${binary:Version}),
         libqt6webenginewidgets6 (= ${binary:Version}),
         qt6-base-dev,
         qt6-declarative-dev,
         qt6-positioning-dev,
         qt6-webengine-dev-tools (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: qt6-pdf-dev (= ${binary:Version})
Description: Qt 6 WebEngine library - development files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 Qt WebEngine provides a Web browser engine that makes it easy to embed content
 from the World Wide Web into your Qt application.
 .
 This package contains the development files needed to build Qt 6 applications
 using Qt WebEngine libraries.

Package: qt6-webengine-private-dev
Architecture: amd64 arm64 armhf i386
Multi-Arch: same
Section: libdevel
Depends: qt6-webengine-dev (= ${binary:Version}), ${misc:Depends}
Description: Qt 6 WebEngine library - private development files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 Qt WebEngine provides a Web browser engine that makes it easy to embed content
 from the World Wide Web into your Qt application.
 .

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

PARALLEL_OPTION = $(filter parallel=%,$(DEB_BUILD_OPTIONS))
ifneq (,$(PARALLEL_OPTION))
       MNUMJOBS = $(patsubst parallel=%,%,$(PARALLEL_OPTION))
       NUMJOBS = $(shell if [ $(MNUMJOBS) -ge 16 ]; then echo "16"; else echo $(MNUMJOBS); fi)
       export NINJAFLAGS = -j$(NUMJOBS)
endif

# Reduce memory consumption on certain architectures
ifeq (armhf, $(DEB_HOST_ARCH))
export LDFLAGS+=-Wl,--no-keep-memory
export NINJAFLAGS = -j2
export NINJAJOBS = -j2
endif

ifeq (i386, $(DEB_HOST_ARCH))
export LDFLAGS+=-Wl,--no-keep-memory
endif


%:
	dh $@ --with pkgkde_symbolshelper --buildsystem=cmake+ninja

touch_files = src/3rdparty/chromium/third_party/devtools-frontend/src/front_end/third_party/lighthouse/lighthouse-dt-bundle.js \
	      src/3rdparty/chromium/third_party/devtools-frontend/src/front_end/third_party/lighthouse/report-assets/report-generator.js \
	      src/3rdparty/chromium/third_party/devtools-frontend/src/front_end/diff/diff_match_patch.js

override_dh_auto_clean:
	# dh_auto_clean
	rm -f $(CURDIR)/src/3rdparty/chromium/third_party/jstemplate/jstemplate_compiled.js
	for fname in $(touch_files); do \
		rm -f $(CURDIR)/$${fname}; \
	done

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DFEATURE_webengine_system_ffmpeg=ON \
		-DFEATURE_webengine_system_icu=ON \
		-DFEATURE_webengine_system_libevent=ON \
		-DFEATURE_qtpdf_build=ON \
		-DFEATURE_qtpdf_widgets_build=ON \
		-DFEATURE_qtpdf_quick_build=ON \
		-DFEATURE_webengine_proprietary_codecs=ON \
		-DFEATURE_webengine_kerberos=ON

	# Create js files, that are needed for building step for arch and indep builds
	cd $(CURDIR)/src/3rdparty/chromium/third_party/jstemplate/; \
		cat util.js jsevalcontext.js jstemplate.js exports.js > jstemplate_compiled.js

	# jQuery
	cp /usr/share/javascript/jquery/jquery.min.js examples/webenginewidgets/contentmanipulation/
	cp /usr/share/javascript/jquery/jquery.min.js src/3rdparty/chromium/third_party/pycoverage/coverage/htmlfiles/
	cp /usr/share/javascript/jquery-tablesorter/jquery.tablesorter.min.js src/3rdparty/chromium/third_party/pycoverage/coverage/htmlfiles/

	set -ex; for fname in $(touch_files); do \
		mkdir -p $(CURDIR)/$$(dirname $${fname}); \
		touch $(CURDIR)/$${fname}; \
	done

execute_after_dh_auto_install:
	# Reproducible builds: remove build paths from .prl files
	sed -i -e '/^QMAKE_PRL_BUILD_DIR/d' debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libQt6*.prl

override_dh_dwz:
